> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://apidocs.polytomic.com/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://apidocs.polytomic.com/_mcp/server. # Update Policy PUT https://app.polytomic.com/api/permissions/policies/{id} Content-Type: application/json Updates an existing policy. The update is a **full replacement** of the policy's bindings. Any role or resource binding not included in the request body is removed. To make a partial change, fetch the current policy with [`GET /api/permissions/policies/{id}`](../../../../api-reference/permissions/policies/get), modify the relevant bindings, and send the complete object back. Reference: https://apidocs.polytomic.com/api-reference/permissions/policies/update ## Authentication - `Authorization` header (basic auth, required) — This is the Polytomic deployment key (on-premises only) - `Authorization` header (bearer token, required) — This is the Polytomic API key ## Request ### Path parameters - `id` (string, required) ### Body (application/json) This endpoint expects a V2UpdatePolicyRequest. - `name` (string, required) - `policy_actions` (list of V2PolicyAction, required, nullable) - `organization_id` (string, optional, nullable) ## Response ### 200 OK - `data` (V2PolicyResponse, optional) ## Errors ### 400 Bad Request Error Bad Request - `key` (string, optional) - `message` (string, optional) - `metadata` (map from string to any, optional) - `status` (integer, optional) ### 401 Unauthorized Error Unauthorized - `code` (integer, optional) — Application-specific error code. - `context` (map from string to any, optional) — Application context. - `error` (string, optional) — Error message. - `status` (string, optional) — Status text. ### 403 Forbidden Error Forbidden - `key` (string, optional) - `message` (string, optional) - `metadata` (map from string to any, optional) - `status` (integer, optional) ### 404 Not Found Error Not Found - `key` (string, optional) - `message` (string, optional) - `metadata` (map from string to any, optional) - `status` (integer, optional) ### 500 Internal Server Error Internal Server Error - `key` (string, optional) - `message` (string, optional) - `metadata` (map from string to any, optional) - `status` (integer, optional) ## Types ### V2PolicyAction - `action` (string, required) - `role_ids` (list of string, required, nullable) ### V2PolicyResponse - `id` (string, optional) - `name` (string, optional) - `organization_id` (string, optional) - `policy_actions` (list of V2PolicyAction, optional) - `system` (boolean, optional) ## Examples **Request** ```json { "name": "Custom", "policy_actions": [ { "action": "read", "role_ids": [ "248df4b7-aa70-47b8-a036-33ac447e668d" ] } ] } ``` **Response** ```json { "data": { "id": "248df4b7-aa70-47b8-a036-33ac447e668d", "name": "Policy", "organization_id": "248df4b7-aa70-47b8-a036-33ac447e668d", "policy_actions": [ { "action": "read", "role_ids": [ "248df4b7-aa70-47b8-a036-33ac447e668d" ] } ], "system": false } } ``` **SDK Code** ```typescript import { PolytomicClient } from "polytomic"; async function main() { const client = new PolytomicClient({ token: "YOUR_TOKEN_HERE", version: "X-Polytomic-Version", }); await client.permissions.policies.update("248df4b7-aa70-47b8-a036-33ac447e668d", { name: "Custom", policy_actions: [ { action: "read", role_ids: [ "248df4b7-aa70-47b8-a036-33ac447e668d", ], }, ], }); } main(); ``` ```python from polytomic import Polytomic, PolicyAction client = Polytomic( token="YOUR_TOKEN_HERE", version="X-Polytomic-Version", ) client.permissions.policies.update( id="248df4b7-aa70-47b8-a036-33ac447e668d", name="Custom", policy_actions=[ PolicyAction( action="read", role_ids=[ "248df4b7-aa70-47b8-a036-33ac447e668d" ], ) ], ) ``` ```go package example import ( context "context" polytomic "github.com/polytomic/polytomic-go/v24" client "github.com/polytomic/polytomic-go/v24/client" option "github.com/polytomic/polytomic-go/v24/option" permissions "github.com/polytomic/polytomic-go/v24/permissions" ) func do() { client := client.NewClient( option.WithToken( "YOUR_TOKEN_HERE", ), option.WithVersion( "X-Polytomic-Version", ), ) request := &permissions.UpdatePolicyRequest{ Name: "Custom", PolicyActions: []*polytomic.PolicyAction{ &polytomic.PolicyAction{ Action: "read", RoleIDs: []string{ "248df4b7-aa70-47b8-a036-33ac447e668d", }, }, }, } client.Permissions.Policies.Update( context.TODO(), "248df4b7-aa70-47b8-a036-33ac447e668d", request, ) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.polytomic.com/api/permissions/policies/248df4b7-aa70-47b8-a036-33ac447e668d") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Put.new(url) request["X-Polytomic-Version"] = 'X-Polytomic-Version' request.basic_auth("", "") request["Content-Type"] = 'application/json' request.body = "{\n \"name\": \"Custom\",\n \"policy_actions\": [\n {\n \"action\": \"read\",\n \"role_ids\": [\n \"248df4b7-aa70-47b8-a036-33ac447e668d\"\n ]\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.put("https://app.polytomic.com/api/permissions/policies/248df4b7-aa70-47b8-a036-33ac447e668d") .header("X-Polytomic-Version", "X-Polytomic-Version") .basicAuth("", "") .header("Content-Type", "application/json") .body("{\n \"name\": \"Custom\",\n \"policy_actions\": [\n {\n \"action\": \"read\",\n \"role_ids\": [\n \"248df4b7-aa70-47b8-a036-33ac447e668d\"\n ]\n }\n ]\n}") .asString(); ``` ```php request('PUT', 'https://app.polytomic.com/api/permissions/policies/248df4b7-aa70-47b8-a036-33ac447e668d', [ 'body' => '{ "name": "Custom", "policy_actions": [ { "action": "read", "role_ids": [ "248df4b7-aa70-47b8-a036-33ac447e668d" ] } ] }', 'headers' => [ 'Content-Type' => 'application/json', 'X-Polytomic-Version' => 'X-Polytomic-Version', ], 'auth' => ['', ''], ]); echo $response->getBody(); ``` ```csharp using RestSharp; using RestSharp.Authenticators; var client = new RestClient("https://app.polytomic.com/api/permissions/policies/248df4b7-aa70-47b8-a036-33ac447e668d"); client.Authenticator = new HttpBasicAuthenticator("", ""); var request = new RestRequest(Method.PUT); request.AddHeader("X-Polytomic-Version", "X-Polytomic-Version"); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"name\": \"Custom\",\n \"policy_actions\": [\n {\n \"action\": \"read\",\n \"role_ids\": [\n \"248df4b7-aa70-47b8-a036-33ac447e668d\"\n ]\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let credentials = Data(":".utf8).base64EncodedString() let headers = [ "X-Polytomic-Version": "X-Polytomic-Version", "Authorization": "Basic \(credentials)", "Content-Type": "application/json" ] let parameters = [ "name": "Custom", "policy_actions": [ [ "action": "read", "role_ids": ["248df4b7-aa70-47b8-a036-33ac447e668d"] ] ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.polytomic.com/api/permissions/policies/248df4b7-aa70-47b8-a036-33ac447e668d")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "PUT" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```